'   ******************************************
'   *  ADJUST 2-LINE ELEMENTS  Version 9314  *
'   ******************************************

'   by David H. Ransom, Jr.
'      7130 Avenida Altisima
'      Rancho Palos Verdes, CA  90274

	DECLARE SUB LineCheck (L$, C1$, C2$)

	DECLARE FUNCTION DMY2JD# (CDay%, CMonth%, CYear%)
	DECLARE FUNCTION InputDMY# (Flag%, JulianDay#, K$)
	DECLARE FUNCTION InputHMS# (Flag%, K$)
	DECLARE FUNCTION LeapYear% (CYear%)

	CLS
	PRINT
	PRINT "Program ADJ2LINE   Version 9314 "
	PRINT
	PRINT "This program will allow the user to convert a set of 2-line"
	PRINT "elements from one epoch to another. For reasonable accuracy,"
	PRINT "the two epochs should be relatively close to each other."
	PRINT
	   
	PRINT "Enter 2-line Filename:  ";
	Y% = CSRLIN
	X% = POS(0)
	INPUT "", FileName$
	FileName$ = UCASE$(FileName$)
	IF INSTR(FileName$, ".") = 0 THEN FileName$ = FileName$ + ".TXT"
	LOCATE Y%, X%
	PRINT FileName$
	FilNum% = FREEFILE
	PRINT "Enter Satellite Name:   ";
	Y% = CSRLIN
	X% = POS(0)
	INPUT "", SatName$
	SatName$ = UCASE$(SatName$)
	IF SatName$ = "" THEN SatName$ = "STS"
	LOCATE Y%, X%
	PRINT SatName$
	   
	ON ERROR GOTO NoFile
	OPEN FileName$ FOR INPUT AS #FilNum%
ReadFile:
	IF EOF(FilNum%) THEN GOTO EndFile
	LINE INPUT #FilNum%, L$
	IF L$ = "" THEN GOTO ReadFile
	IF LEFT$(L$, 1) = " " THEN GOTO ReadFile
	IF LEFT$(L$, 1) = "-" THEN GOTO ReadFile
	IF UCASE$(LEFT$(L$, LEN(SatName$))) <> SatName$ THEN
		LINE INPUT #FilNum%, L$
		LINE INPUT #FilNum%, L$
		GOTO ReadFile
	END IF
	Line0$ = L$
	LINE INPUT #FilNum%, Line1$
	LINE INPUT #FilNum%, Line2$

	PRINT
	PRINT "The 2-line elements read for this satellite are:"
	PRINT
	PRINT TAB(5); Line0$
	PRINT TAB(5); Line1$
	PRINT TAB(5); Line2$
	PRINT
	LOCATE , , 1
	PRINT "Press ENTER to ACCEPT this satellite,"
	PRINT "or any other key to continue searching:  ";
	DO: K$ = INKEY$: LOOP WHILE K$ = ""
	IF K$ <> CHR$(13) THEN PRINT "NO": PRINT : GOTO ReadFile
	PRINT "YES"
	PRINT
	CLOSE

	PRINT "Enter dates as 'MM/DD/YY' or press ENTER if dates are the same"
	PRINT
	PRINT "Enter Original Date:    ";
	Y% = CSRLIN
	X% = POS(0)
	K$ = ""
	OrigJD# = InputDMY(Flag%, JD#, K$)
	IF Flag% = 0 OR Flag% = 3 THEN
		LOCATE Y%, X%
		PRINT "(dates are the same)"
		NewDays% = 0
		GOTO SetTime
	END IF
	PRINT "Enter New Date:         ";
	K$ = ""
	NewJD# = InputDMY(Flag%, JD#, K$)
	IF Flag% = 0 OR Flag% = 3 THEN
		LOCATE Y%, X%
		PRINT "(dates are the same)"
		OrigJD# = 0
		NewJD# = 0
	END IF
	NewDays% = NewJD# - OrigJD#

SetTime:
	PRINT
	PRINT "Enter times as 'HH:MM:SS', 'HH:MM.MM', or 'HH.HHHH'"
	PRINT
	PRINT "Enter Original Time:    ";
	K$ = ""
	Epoch1# = InputHMS(Flag%, K$) / 24#
	PRINT "Enter New Time:         ";
	K$ = ""
	Epoch2# = InputHMS(Flag%, K$) / 24#
	PRINT
	OrigEpoch$ = MID$(Line1$, 19, 14)
	FOR N% = 3 TO 4
		IF MID$(OrigEpoch$, N%, 1) = " " THEN MID$(OrigEpoch$, N%, 1) = "0"
	NEXT N%
	OrigEpoch# = VAL(OrigEpoch$)
	PRINT "Original Epoch:         "; OrigEpoch$
	OrigRAAN$ = MID$(Line2$, 18, 8)
	OrigRAAN# = VAL(OrigRAAN$)
	PRINT "Original RAAN:            "; OrigRAAN$


	DeltaDays# = Epoch2# - Epoch1# + NewDays%
	NewEpoch# = OrigEpoch# + DeltaDays#
	DeltaDegrees# = DeltaDays# * 360# * 1.00273908#
	NewRAAN# = OrigRAAN# + DeltaDegrees#
	WHILE NewRAAN# >= 360#
		NewRAAN# = NewRAAN# - 360#
	WEND
	WHILE NewRAAN# < 0#
		NewRAAN# = NewRAAN# + 360#
	WEND

	PRINT
	PRINT USING "Estimated New Epoch:    #####.########"; NewEpoch#
	PRINT USING "Estimated New RAAN:       ###.####"; NewRAAN#
	   
	NewTime$ = LTRIM$(RTRIM$(STR$(INT((NewEpoch# - FIX(NewEpoch#)) * 100000000# + .5))))
	DO WHILE LEN(NewTime$) < 8
		NewTime$ = "0" + NewTime$
	LOOP
	NewEpoch$ = LTRIM$(RTRIM$(STR$(FIX(NewEpoch#)))) + "." + NewTime$
	   
	NewFrac$ = LTRIM$(RTRIM$(STR$(INT((NewRAAN# - FIX(NewRAAN#)) * 10000# + .5))))
	DO WHILE LEN(NewFrac$) < 4
		NewFrac$ = "0" + NewFrac$
	LOOP
	NewRAAN$ = LTRIM$(RTRIM$(STR$(FIX(NewRAAN#))))
	DO WHILE LEN(NewRAAN$) < 3
		NewRAAN$ = " " + NewRAAN$
	LOOP
	NewRAAN$ = NewRAAN$ + "." + NewFrac$
	   
	MID$(Line1$, 19, 14) = NewEpoch$
	LineCheck Line1$, C1$, C2$
	MID$(Line2$, 18, 8) = NewRAAN$
	LineCheck Line2$, C1$, C2$
	PRINT
	PRINT "The new 2-line elements for this satellite are:"
	PRINT
	PRINT TAB(5); Line0$
	PRINT TAB(5); Line1$
	PRINT TAB(5); Line2$
	PRINT

FileOutput:
	PRINT "Enter new 2-line Filename [NEW2LINE.TXT]:  ";
	Y% = CSRLIN
	X% = POS(0)
	INPUT "", FileName$
	FileName$ = UCASE$(FileName$)
	IF FileName$ = "" THEN FileName$ = "NEW2LINE.TXT"
	IF INSTR(FileName$, ".") = 0 THEN FileName$ = FileName$ + ".TXT"
	LOCATE Y%, X%
	PRINT FileName$
	IF LEN(DIR$(FileName$)) > 0 THEN
		PRINT "File "; FileName$; " already exists! Overwrite? [Y,n]:  ";
YesNo:
		DO: K$ = INKEY$: LOOP WHILE LEN(K$) = 0
		IF K$ = CHR$(13) THEN K$ = "Y"
		K$ = UCASE$(K$)
		IF K$ = "N" THEN
			PRINT "NO"
			GOTO FileOutput
		ELSEIF K$ <> "Y" THEN
			GOTO YesNo
		END IF
		PRINT "YES"
	END IF
	FilNum% = FREEFILE
	OPEN FileName$ FOR OUTPUT AS FilNum%
	PRINT #FilNum%, Line0$
	PRINT #FilNum%, Line1$
	PRINT #FilNum%, Line2$
	CLOSE

	SYSTEM


NoFile:
	PRINT
	PRINT "The requested file "; FileName$; " cannot be found!"
	SYSTEM

EndFile:
	PRINT
	PRINT "The requested satellite '"; SatName$; "...' was not found!"
	SYSTEM
DEFINT A-Z

DEFSNG A-Z
FUNCTION DMY2JD# (CDay%, CMonth%, CYear%)

' =====> NOTE: This function calculates the Julian Date at 12:00:00  <=====

' DMY2JD# converts the given date into JD, the number of Julian days
' elapsed since -4713 January 1.5. Note: DJD = JD - 2415020. Method
' adapted from Roger Minnott, Sky & Telescope, May 1984, p 455.

' This version valid only for CYear% > 1582.

	DEFINT A-Z
		J# = -INT(7 * (INT((CMonth + 9) / 12) + CYear) / 4)

		S = SGN(CMonth - 9)
		A = ABS(CMonth - 9)
		J1 = INT(CYear + S * INT(A / 7))
	J1 = -INT((INT(J1 / 100) + 1) * .75)

		J# = J# + INT(275 * CMonth / 9) + CDay + J1
		Y# = 367# * CYear
	DMY2JD# = 1721028.5# + J# + Y#
END FUNCTION

DEFSNG A-Z
FUNCTION InputDMY# (Flag%, JulianDay#, K$)

'       Flag% is set as follows on return:

'      <0 = Error Number
'       0 = ENTER (No data entered)
'       1 = Local date input, output is LOCAL JD ===> USE CAUTION! <===
'       2 = UT date input, output is JD
'       3 = +/-/JD/DJD/MJD/TJD/GSD input, output is JD

	DEFINT A-Z

InputDMY0:
	Flag% = 0
	IF K$ = "" THEN LINE INPUT K$
	LD = 1: LM = 1: LY = 1993
	IF LEN(K$) = 0 THEN EXIT FUNCTION
	K$ = UCASE$(K$)
	IF LEFT$(K$, 1) = "#" THEN
		InputDMY# = INT(JulianDay#) + .5#
		Flag% = 3
		EXIT FUNCTION
	END IF
	IF LEFT$(K$, 1) = "*" THEN
		InputDMY# = JulianDay#
		Flag% = 3
		EXIT FUNCTION
	END IF
	IF LEFT$(K$, 1) = "+" THEN
		InputDMY# = JulianDay# + VAL(MID$(K$, 2))
		Flag% = 3
		EXIT FUNCTION
	END IF
	IF LEFT$(K$, 1) = "-" THEN
		InputDMY# = JulianDay# - VAL(MID$(K$, 2))
		Flag% = 3
		EXIT FUNCTION
	END IF
	IF LEFT$(K$, 2) = "JD" THEN
		InputDMY# = VAL(MID$(K$, 3))
		Flag% = 3
		EXIT FUNCTION
	ELSEIF LEFT$(K$, 3) = "DJD" THEN
		InputDMY# = VAL(MID$(K$, 4)) + 2415020#
		Flag% = 3
		EXIT FUNCTION
	ELSEIF LEFT$(K$, 3) = "MJD" THEN
		InputDMY# = VAL(MID$(K$, 4)) + 2400000.5#
		Flag% = 3
		EXIT FUNCTION
	ELSEIF LEFT$(K$, 3) = "TJD" THEN
		InputDMY# = VAL(MID$(K$, 4)) + 2440000.5#
		Flag% = 3
		EXIT FUNCTION
	ELSEIF LEFT$(K$, 3) = "GSD" THEN
		InputDMY# = (VAL(MID$(K$, 4)) - .671104312#) / 1.00273790934#
		Flag% = 3
		EXIT FUNCTION
	END IF
	IF RIGHT$(K$, 1) = "U" THEN Flag% = 2 ELSE Flag% = 1
	LM = VAL(K$)
	LDF# = 0
	Test = INSTR(K$, "/"): 'find first slash
	IF Test = 0 THEN GOTO InputDMY1
	IF INSTR(LEFT$(K$, Test), ".") THEN Flag% = 3: 'Force UT if decimal pt
	K$ = MID$(K$, Test + 1)
	LD = VAL(K$)
	Test = INSTR(K$, "/"): 'find second slash
	IF Test = 0 THEN GOTO InputDMY1
	K$ = MID$(K$, Test + 1)
	LY = VAL(K$)

InputDMY1:
	IF LY >= 0 AND LY < 50 THEN
		LY = LY + 2000
	ELSEIF LY >= 50 AND LY < 100 THEN
		LY = LY + 1900
	END IF
	IF LY = 1582 AND LM = 10 AND LD > 4 AND LD < 15 THEN
		ErrorNum = 24
		GOTO ShowDMYError
	END IF

	IF LM < 0 OR LM > 12 THEN
		ErrorNum = 26
		GOTO ShowDMYError
	END IF

	IF LeapYear(LY) = 0 AND LM = 2 AND LD = 29 THEN
		ErrorNum = 25
		GOTO ShowDMYError
	END IF

	SELECT CASE LM
		CASE 2
			TestDays = 28
		CASE 4, 6, 9, 11
			TestDays = 30
		CASE ELSE
			TestDays = 31
	END SELECT

	IF LeapYear(LY) = 1 AND LM = 2 THEN TestDays = 29
	   
	IF LD < 0 OR LD > TestDays THEN
		ErrorNum = 26
		GOTO ShowDMYError
	END IF
	   
	InputDMY# = DMY2JD#(LD, LM, LY) + LDF#
	EXIT FUNCTION

ShowDMYError:
	Flag = -ErrorNum
	EXIT FUNCTION
END FUNCTION

DEFSNG A-Z
FUNCTION InputHMS# (Flag%, K$)

'       Returns the time input and sets Flag% as follows:

'       0 = No time input               (CR pressed)
'       1 = Local time requested
'       2 = UTC/GMT time requested      (No conversions performed)

	IF K$ = "" THEN LINE INPUT K$
	Flag% = 0
	InputHMS# = 0
	IF K$ = "" THEN EXIT FUNCTION
	K$ = UCASE$(K$)
	SELECT CASE RIGHT$(K$, 1)
		CASE "U", "G"
			Flag% = 2
		CASE ELSE
			Flag% = 1
	END SELECT
	Test# = VAL(K$)
	InputHMS# = Test#
	Test% = INSTR(K$, ":"): 'Find first colon
	IF Test% = 0 THEN Test% = INSTR(K$, ","): 'Try comma instead
	IF Test% = 0 THEN EXIT FUNCTION
	K$ = MID$(K$, Test% + 1)
	Test# = Test# + VAL(K$) / 60
	InputHMS# = Test#
	Test% = INSTR(K$, ":"): 'Find second colon
	IF Test% = 0 THEN Test% = INSTR(K$, ","): 'Try comma instead
	IF Test% = 0 THEN EXIT FUNCTION
	K$ = MID$(K$, Test% + 1)
	InputHMS# = Test# + VAL(K$) / 3600
END FUNCTION

FUNCTION LeapYear% (CYear%)
	  
'       Function LeapYear determines if CYear% is a Leap Year (LeapYear=1)
'       or not (LeapYear=0). This version valid for CYear% > 1582.

	DEFINT A-Z
		IF CYear MOD 4 = 0 THEN IsLeap = 1 ELSE IsLeap = 0
		IF CYear MOD 100 = 0 THEN
				IF CYear MOD 400 = 0 THEN
			IsLeap = 1
		ELSE
			IsLeap = 0
		END IF
	END IF
	LeapYear = IsLeap
END FUNCTION

DEFSNG A-Z
SUB LineCheck (L$, C1$, C2$)
	   
'       This subroutine computes the checksum for the 2-line elements
'       line and substitutes the new value for the old in L$. C1$ is
'       the original checksum and C2$ is the new checksum. The length
'       of L$ upon return is adjusted if necessary to 69 characters.

	IF LEN(L$) > 69 THEN L$ = LEFT$(L$, 69)
	IF LEN(L$) < 69 THEN L$ = L$ + SPACE$(69 - LEN(L$))
	C1$ = MID$(L$, 69, 1)
	Sum% = 0
	FOR PTR% = 1 TO LEN(L$) - 1
		Char% = ASC(MID$(L$, PTR%, 1))
		IF Char% >= 48 AND Char% <= 57 THEN
			Sum% = Sum% + Char% - 48
		ELSEIF Char% = ASC("-") THEN
			Sum% = Sum% + 1
		ELSEIF Char% = ASC("+") THEN
			Sum% = Sum% + 2
		ELSE
		END IF
	NEXT
	C2$ = CHR$((Sum% MOD 10) + 48)
	MID$(L$, 69, 1) = C2$
END SUB

